INCLUDE CLIBC_16.INC

;strcmp() -- Compare strings
;int __near strcmp(const char __near * const, char __near * const);
; GIVEN:
;   p_str1	near pointer, offset from ds
;   p_str2	near pointer, offset from ds
; RETURNS:
;   <0	if str1 < str2
;   0	if str1 = str2 (identical)
;   >0	if str1 > str2

_TEXT SEGMENT
strcmp PROC NEAR16 C USES es si di, p_str1:NEAR16 PTR BYTE, p_str2:NEAR16 PTR BYTE

	    mov ax, ds
	    mov es, ax

	    mov di,[p_str1]	    ;es:di = destination
	    mov si,[p_str2]	    ;ds:si = source

@@loop:     lods BYTE PTR ds:[si]   ;Load str2 char al
	    mov ah, es:[di]	    ;Load str1 char ah
            inc di
	    cmp ah,al		   ;Not equal?
	    jne @@done
	    test al, al
	    jnz @@loop
	    ; equal
	    xor ax, ax
	    jmp @@exit
@@done:
	    jl @@less
	    ; str1 > str2
	    xor ax, ax
	    inc ax
	    jmp @@exit
@@less:
	    ; str1 < str2
	    xor ax, ax
	    dec ax
@@exit:
	    ret
strcmp ENDP

; __fastcall
;   bx	    p_str1, (dest) offset from ds
;   ax	    p_str2, (source) offset form ds
;int __fastcall __near strcmp(const char __near * const, char __near * const);
@strcmp PROC NEAR16 USES es si di

	    mov di, bx	    ;es:di = p_str1
	    mov si, ax	    ;ds:si = p_str2

	    mov ax, ds
	    mov es, ax


@@loop:     lods BYTE PTR ds:[si]   ;Load str2 char al
	    mov ah, es:[di]	    ;Load str1 char ah
            inc di
	    cmp ah,al		   ;Not equal?
	    jne @@done
	    test al,al		    ;Loop while not zero
	    jnz @@loop
	    ; str1 = str2
	    xor ax, ax		    ; equal strings
	    jmp @@exit
@@done:
	    jl @@less
	    ; str1 > str2
	    xor ax, ax
	    inc ax
	    jmp @@exit
@@less:
	    ; str1 < str2
	    xor ax, ax
	    dec ax
@@exit:
	    ret
@strcmp ENDP

;int __near strcmp_sss(const char __near * const, char __near * const);
; GIVEN:
;   p_str1	near pointer, (dest) offset from ds
;   p_str2	near pointer, (source) offset from ss
; RETURNS:
;   <0	if str1 < str2
;   0	if str1 = str2 (identical)
;   >0	if str1 > str2
strcmp_sss PROC NEAR16 C USES ds es si di, p_str1:NEAR16 PTR BYTE, p_str2:NEAR16 PTR BYTE
	    mov bx, ds
	    mov es, bx

	    mov ax, ss
	    mov ds, ax

	    mov di,[p_str1]	    ;es:di = destination
	    mov si,[p_str2]	    ;ds:si = source

@@loop:     lods BYTE PTR ds:[si]   ;Load str2 char al
	    mov ah, es:[di]	    ;Load str1 char ah
            inc di
	    cmp ah,al		   ;Not equal?
	    jne @@done
	    test al, al
	    jnz @@loop
	    ; equal
	    xor ax, ax
	    jmp @@exit
@@done:
	    jl @@less
	    ; str1 > str2
	    xor ax, ax
	    inc ax
	    jmp @@exit
@@less:
	    ; str1 < str2
	    xor ax, ax
	    dec ax
@@exit:
	    ret
strcmp_sss ENDP

; __fastcall
;   bx	    p_str1, (dest) offset from ds
;   ax	    p_str2, (source) offset form ss
;int __fastcall __near strcmp(const char __near * const, char __near * const);
@strcmp_sss PROC NEAR16 USES ds es si di

	    mov di, bx	    ;es:di = p_str1
	    mov si, ax	    ;ds:si = p_str2

	    mov ax, ds
	    mov es, ax

	    mov ax, ss
	    mov ds, ax


@@loop:     lods BYTE PTR ds:[si]   ;Load str2 char al
	    mov ah, es:[di]	    ;Load str1 char ah
            inc di
	    cmp ah,al		   ;Not equal?
	    jne @@done
	    test al,al		    ;Loop while not zero
	    jnz @@loop
	    ; str1 = str2
	    xor ax, ax		    ; equal strings
	    jmp @@exit
@@done:
	    jl @@less
	    ; str1 > str2
	    xor ax, ax
	    inc ax
	    jmp @@exit
@@less:
	    ; str1 < str2
	    xor ax, ax
	    dec ax
@@exit:
	    ret
@strcmp_sss ENDP

;int __near strcmp_dss(const char __near * const, char __near * const);
; GIVEN:
;   p_str1	near pointer, (dest) offset from ss
;   p_str2	near pointer, (source) offset from ds
; RETURNS:
;   <0	if str1 < str2
;   0	if str1 = str2 (identical)
;   >0	if str1 > str2
strcmp_dss PROC NEAR16 C USES ds es si di, p_str1:NEAR16 PTR BYTE, p_str2:NEAR16 PTR BYTE
	    mov bx, ss
	    mov es, bx

	    mov di,[p_str1]	    ;es:di = destination
	    mov si,[p_str2]	    ;ds:si = source

@@loop:     lods BYTE PTR ds:[si]   ;Load str2 char al
	    mov ah, es:[di]	    ;Load str1 char ah
            inc di
	    cmp ah,al		   ;Not equal?
	    jne @@done
	    test al, al
	    jnz @@loop
	    ; equal
	    xor ax, ax
	    jmp @@exit
@@done:
	    jl @@less
	    ; str1 > str2
	    xor ax, ax
	    inc ax
	    jmp @@exit
@@less:
	    ; str1 < str2
	    xor ax, ax
	    dec ax
@@exit:
	    ret
strcmp_dss ENDP

; __fastcall
;   bx	    p_str1, (dest) offset from ss
;   ax	    p_str2, (source) offset form ds
;int __fastcall __near strcmp(const char __near * const, char __near * const);
@strcmp_dss PROC NEAR16 USES es si di

	    mov di, bx	    ;es:di = p_str1
	    mov si, ax	    ;ds:si = p_str2

	    mov ax, ss
	    mov es, ax

@@loop:     lods BYTE PTR ds:[si]   ;Load str2 char al
	    mov ah, es:[di]	    ;Load str1 char ah
            inc di
	    cmp ah,al		   ;Not equal?
	    jne @@done
	    test al,al		    ;Loop while not zero
	    jnz @@loop
	    ; str1 = str2
	    xor ax, ax		    ; equal strings
	    jmp @@exit
@@done:
	    jl @@less
	    ; str1 > str2
	    xor ax, ax
	    inc ax
	    jmp @@exit
@@less:
	    ; str1 < str2
	    xor ax, ax
	    dec ax
@@exit:
	    ret
@strcmp_dss ENDP
_TEXT ENDS
END
