/* string.h, clibc_16.lib */

#ifndef _SIZE_T_DEFINED
typedef unsigned int size_t;
#define _SIZE_T_DEFINED
#endif

/* *************** */
/* strcpy */
#ifdef FASTCALL_STRCPY
char __near * __fastcall __near strcpy(char __near * const, const char __near * const);
#else
char __near * __near strcpy(char __near * const, const char __near * const);
#endif

#ifdef FASTCALL_STRCPY_SSS
char __near * __fastcall __near strcpy_sss(char __near * const, const char __near * const);
#else
char __near * __near strcpy_sss(char __near * const, const char __near * const);
#endif

#ifdef FASTCALL_STRCPY_DSS
char __near * __fastcall __near strcpy_dss(char __near * const, const char __near * const);
#else
char __near * __near strcpy_dss(char __near * const, const char __near * const);
#endif

/* *********** */
/* strlen */
#ifdef FASTCALL_STRLEN
size_t __fastcall __near strlen(const char __near * const);
#else
size_t __near strlen(const char __near * const);
#endif

#ifdef FASTCALL_STRLEN_SSS
size_t __fastcall __near strlen_sss(const char __near * const);
#else
size_t __near strlen_ssss(const char __near * const);
#endif

/* ************ */
/* skipsp */
#ifdef FASTCALL_SKIPSP
char __near * __fastcall __near skipsp(const char __near * const);
#else
char __near * __near skipsp(const char __near * const);
#endif

#ifdef FASTCALL_SKIPSP_SSS
char __near * __fastcall __near skipsp_sss(const char __near * const);
#else
char __near * __near skipsp_sss(const char __near * const);
#endif

/* ************ */
/* skiptosp */
#ifdef FASTCALL_SKIPTOSP
char __near * __fastcall __near skiptosp(const char __near * const);
#else
char __near * __near skiptosp(const char __near * const);
#endif

#ifdef FASTCALL_SKIPTOSP_SSS
char __near * __fastcall __near skiptosp_sss(const char __near * const);
#else
char __near * __near skiptosp_sss(const char __near * const);
#endif

#ifdef FASTCALL_STRCAT
char __near * __fastcall __near strcat(char __near * const, const char __near * const);
#else
char __near * __near strcat(char __near * const, const char __near * const);
#endif

#ifdef FASTCALL_STRCAT_SSS
char __near * __fastcall __near strcat_sss(char __near * const, const char __near * const);
#else
char __near * __near strcat_sss(char __near * const, const char __near * const);
#endif

#ifdef FASTCALL_STRCAT_DSS
char __near * __fastcall __near strcat_dss(char __near * const, const char __near * const);
#else
char __near * __near strcat_dss(char __near * const, const char __near * const);
#endif

#ifdef FASTCALL_STRCMP
int __fastcall __near strcmp(const char __near * const, char __near * const);
#else
int __near strcmp(const char __near * const, char __near * const);
#endif

#ifdef FASTCALL_STRCMP_SSS
int __fastcall __near strcmp_sss(const char __near * const, char __near * const);
#else
int __near strcmp_sss(const char __near * const, char __near * const);
#endif

#ifdef FASTCALL_STRCMP_DSS
int __fastcall __near strcmp_dss(const char __near * const, char __near * const);
#else
int __near strcmp_dss(const char __near * const, char __near * const);
#endif

#ifdef FASTCALL_STRCHR
char __near * __fastcall __near strchr(const char __near * const,const int);
#else
char __near *	__near strchr(const char __near * const,const int);
#endif

#ifdef FASTCALL_STRCHR_SSS
char __near * __fastcall __near strchr_sss(const char __near * const,const int);
#else
char __near *	__near strchr_sss(const char __near * const,const int);
#endif

#ifdef FASTCALL_STRSTR
char __near * __fastcall __near strstr(const char __near * const, const char __near * const);
#else
char __near *	__near strstr(const char __near * const, const char __near * const);
#endif

#ifdef FASTCALL_STRSTR_SSS
char __near * __fastcall __near strstr_sss(const char __near * const, const char __near * const);
#else
char __near *	__near strstr_sss(const char __near * const, const char __near * const);
#endif

#ifdef FASTCALL_STRSTR_DSS
char __near * __fastcall __near strstr_sss(const char __near * const, const char __near * const);
#else
char __near *	__near strstr_sss(const char __near * const, const char __near * const);
#endif

#ifdef FASTCALL_STRRCHR
char __near * __fastcall __near strrchr(const char __near * const, const int);
#else
char __near * __near strrchr(const char __near * const, const int);
#endif

#ifdef FASTCALL_STRRCHR_SSS
char __near * __fastcall __near strrchr_sss(const char __near * const, const int);
#else
char __near * __near strrchr_sss(const char __near * const, const int);
#endif

#ifdef FASTCALL_STRICMP
int __fastcall __near stricmp(const char __near * const, const char __near * const);
#else
int __near stricmp(const char __near * const, const char __near * const);
#endif

#ifdef FASTCALL_SKIPSPR
char __near * __fastcall __near skipspr(const char __near * const);
#else
char __near * __near skipspr(const char __near * const);
#endif

#ifdef FASTCALL_SKIPSPR_SSS
char __near * __fastcall __near skipspr_sss(const char __near * const);
#else
char __near * __near skipspr_sss(const char __near * const);
#endif

#ifdef FASTCALL_SKIPTOSR
char __near * __fastcall __near skiptosr(const char __near * const);
#else
char __near * __near skiptosr(const char __near * const);
#endif

#ifdef FASTCALL_SKIPTOSR_SSS
char __near * __fastcall __near skiptosr_sss(const char __near * const);
#else
char __near * __near skiptosr_sss(const char __near * const);
#endif

#ifdef FASTCALL_STRLWR
char __near * __fastcall __near strlwr(char __near * const);
#else
char __near * __near strlwr(char __near * const);
#endif

#ifdef FASTCALL_STRLWR_SSS
char __near * __fastcall __near strlwr_sss(char __near * const);
#else
char __near * __near strlwr_sss(char __near * const);
#endif

#ifdef FASTCALL_STRUPR
char __near * __fastcall __near strupr(char __near * const);
#else
char __near * __near strupr(char __near * const);
#endif

#ifdef FASTCALL_STRUPR_SSS
char __near * __fastcall __near strupr_sss(char __near * const);
#else
char __near * __near strupr_sss(char __near * const);
#endif

#ifdef FASTCALL_STRNCPY
char __near * __fastcall __near strncpy(char __near * const, const char __near * const, const size_t);
#else
char __near * __near strncpy(char __near * const, const char __near * const, const size_t);
#endif

#ifdef FASTCALL_STRNCPY_SSS
char __near * __fastcall __near strncpy_sss(char __near * const, const char __near * const, const size_t);
#else
char __near * __near strncpy_sss(char __near * const, const char __near * const, const size_t);
#endif

#ifdef FASTCALL_STRNCPY_DSS
char __near * __fastcall __near strncpy_dss(char __near * const, const char __near * const, const size_t);
#else
char __near * __near strncpy_dss(char __near * const, const char __near * const, const size_t);
#endif

#ifdef FASTCALL_STRNCAT
char __near * __fastcall __near strncat(char __near * const, const char __near * const, const int);
#else
char __near * __near strncat(char __near * const, const char __near * const, const int);
#endif

#ifdef FASTCALL_STRNCAT_SSS
char __near * __fastcall __near strncat_sss(char __near * const, const char __near * const, const int);
#else
char __near * __near strncat_sss(char __near * const, const char __near * const, const int);
#endif

#ifdef FASTCALL_STRNCAT_DSS
char __near * __fastcall __near strncat_dss(char __near * const, const char __near * const, const int);
#else
char __near * __near strncat_dss(char __near * const, const char __near * const, const int);
#endif

#ifdef FASTCALL_MEMMOVE
void __near * __fastcall __near memmove(void __near * const, void __near * const, const int);
#else
void __near * __near memmove(void __near * const, void __near * const, const int);
#endif

#ifdef FASTCALL_MEMMOVE_SSS
void __near * __fastcall __near memmove_sss(void __near * const, void __near * const, const int);
#else
void __near * __near memmove_sss(void __near * const, void __near * const, const int);
#endif

#ifdef FASTCALL_MEMMOVE_DSS
void __near * __fastcall __near memmove_dss(void __near * const, void __near * const, const int);
#else
void __near * __near memmove_dss(void __near * const, void __near * const, const int);
#endif

#ifdef FASTCALL_MEMSET
void __near * __fastcall __near memset(void __near * const, const int, const int);
#else
void __near * __near memset(void __near * const, const int, const int);
#endif

#ifdef FASTCALL_MEMSET_SSS
void __near * __fastcall __near memset_sss(void __near * const, const int, const int);
#else
void __near * __near memset_sss(void __near * const, const int, const int);
#endif

#ifdef FASTCALL_MEMCMP
int __fastcall __near memcmp(const void __near * const, const void __near * const, const int);
#else
int __near memcmp(const void __near * const, const void __near * const, const int);
#endif

#ifdef FASTCALL_MEMCMP_SSS
int __fastcall __near memcmp_sss(const void __near * const, const void __near * const, const int);
#else
int __near memcmp_sss(const void __near * const, const void __near * const, const int);
#endif
